#include "fattura.h"


char readFattura(fattura * p, FILE * f)
{
	readField(p->cf, ' ', f);
	fscanf(f, "%f ", &(p->importo));
	return readField(p->data, ' ', f);
}


int compareFatture(fattura f1, fattura f2)
{
	int result;

	result = strcmp(f1.data, f2.data);
	if ( result != 0)
	{
		return result;
	}
	else
	{
		if (f1.importo<f2.importo)
			return -1;
		else if (f1.importo==f2.importo)
			return 0;
		else return 1;
	}
}


boolean insert(fattura fatArray[], fattura el, int dim, int *elCount)
{
	int i = 0, j;
	
	boolean found = false;
	
	if (*elCount < dim)
	{
		while (i < *elCount && !found)
		{
			if (compareFatture(el, fatArray[i]) <= 0)
				found = true;
			else
				i++;
		}
		if (found)
			for(j = *elCount; j > i; j--)
				fatArray[j] = fatArray[j - 1]; /* shift */
		fatArray[i] = el;
		(*elCount)++;
		return true;
	}
	return false;
}


fattura * filter(list pList, int * logicDim)
{
	fattura * result;
	fattura f;
	patient p;
	FILE * fTemp;
	char read;

	result = (fattura *) malloc(sizeof(fattura) * 1000);
	*logicDim = 0;

	while (!empty(pList))
	{
		p = head(pList);
		fTemp = fopen(p.fileFatture, "r");
		
		do
		{
			read = readFattura(&f, fTemp);
			if (!compareCF(f.cf, p.cf))
			{
				strcpy(f.nomeFile, p.fileFatture);
				insert(result, f, 1000, logicDim);
			}
		} while ( read != EOF);
		fclose(fTemp);
		pList = tail(pList);
	}
	return result;
}