#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "element.h"
#include "list.h"
#include "readField.h"
#include "patient.h"

#ifndef FATTURA
#define FATTURA

#define DIM_DATA 9

typedef struct fattura {
	char cf[DIM_CF];
	char data[DIM_DATA];
	float importo;
	char nomeFile[DIM_NOMEFILE];
}
fattura;

typedef enum {false, true} boolean;

#endif


char readFattura(fattura * p, FILE * f);
int compareFatture(fattura f1, fattura f2);
boolean insert(fattura fatArray[], fattura el, int dim, int *elCount);
fattura * filter(list pList, int * logicDim);